<template>
  <v-btn
    variant="tonal"
    prepend-icon="mdi-calendar-filter"
    class="text-gray-600 transition-all"
    :class="{
      'text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500': (
        appliedCount > 0
      ),
    }"
    :text="buttonLabel"
    :loading="loading"
    rounded
    @click="isShown = true"
  />

  <v-bottom-sheet
    v-model="isShown"
    content-class="!shadow-none"
    class="w-full md:w-3/5 lg:w-2/5 xl:w-1/3 mx-auto min-w-[360px]"
  >
    <v-card>
      <v-card-text>
        <section class="flex items-center">
          <FormHeader
            icon="mdi-filter"
            headline="Бронирования"
            subtitle="Выберите нужные фильтры"
            class="flex-auto"
          />

          <v-btn
            icon="mdi-close"
            variant="text"
            @click="isShown = false"
          />
        </section>

        <FormRow>
          <PluginDatePicker
            v-model.range="selectedDates"
            :locale="{ id: 'ru', masks: { weekdays: 'WW' } }"
            mode="date"
            color="teal"
            class="w-full"
            :select-attribute="{
              highlight: {
                start: { contentStyle: { color: 'white' } },
                end: { contentStyle: { color: 'white' } },
              },
            }"
          />
        </FormRow>

        <FormRow>
          <PropertyFilter v-model="selectedProperty" />
        </FormRow>

        <FormRow>
          <GuestFilter v-model="selectedGuest" />
        </FormRow>

        <FormRow>
          <v-btn-toggle
            v-model="selectedStatus"
            class="grid grid-cols-2 !h-auto"
            mandatory
          >
            <v-btn
              :value="BookingStatus.BOOKED"
              append-icon="mdi-calendar-lock"
              class="text-amber-600 py-4"
              text="Забронирован"
            />

            <v-btn
              :value="BookingStatus.ACTIVE"
              append-icon="mdi-calendar-account"
              class="text-teal-500 py-4"
              text="Активный"
            />

            <v-btn
              :value="BookingStatus.DONE"
              append-icon="mdi-calendar-check"
              class="text-blue-500 py-4"
              text="Завершен"
            />

            <v-btn
              :value="BookingStatus.CANCELLED"
              append-icon="mdi-calendar-remove"
              class="text-red-500 py-4"
              text="Отменен"
            />
          </v-btn-toggle>
        </FormRow>

        <v-divider class="border-gray-800 my-4" />

        <FormRow
          spacing="large"
          class="flex items-center justify-around gap-4 mx-auto"
        >
          <v-btn
            rounded
            size="large"
            variant="tonal"
            @click="onClearClick"
          >
            Сбросить
          </v-btn>

          <v-btn
            rounded
            size="large"
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            @click="onApplyClick"
          >
            Применить
          </v-btn>
        </FormRow>
      </v-card-text>
    </v-card>
  </v-bottom-sheet>
</template>

<script setup lang="ts">
import { computed, reactive, ref } from 'vue';

import { BookingStatus } from '@/declarations';
import { useDateTime } from '@/composables';

import FormHeader from '@/components/layout/FormHeader.vue';
import FormRow from '@/components/layout/FormRow.vue';

import PropertyFilter from './PropertyFilter.vue';
import GuestFilter from './GuestFilter.vue';

defineProps<{ loading: boolean }>();
const emit = defineEmits(['apply']);

const dt = useDateTime();
const isShown = ref(false);

const selectedDates = ref<IBookingFilters['dates']>({ start: null, end: null });
const selectedProperty = ref<IBookingFilters['property']>(null);
const selectedGuest = ref<IBookingFilters['guest']>(null);
const selectedStatus = ref<IBookingFilters['status']>(null);

const appliedFilters = reactive<IBookingFilters>({
  dates: { start: null, end: null },
  property: null,
  guest: null,
  status: null,
});

const appliedCount = computed(() => {
  let count = 0;

  if (appliedFilters.dates?.start && appliedFilters.dates?.end) count += 1;
  if (appliedFilters.property) count += 1;
  if (appliedFilters.guest) count += 1;
  if (appliedFilters.status) count += 1;

  return count;
});

const buttonLabel = computed(() => {
  return appliedCount.value > 0
    ? `Фильтры (${appliedCount.value})`
    : 'Фильтры';
});

const applyFilters = () => {
  const start = selectedDates.value?.start;
  const end = selectedDates.value?.end;

  appliedFilters.property = selectedProperty.value;
  appliedFilters.guest = selectedGuest.value;
  appliedFilters.status = selectedStatus.value;

  appliedFilters.dates = !start || !end
    ? { start: null, end: null }
    : {
      start: dt.wrap(start).startOf('day').toJSDate(),
      end: dt.wrap(end).endOf('day').toJSDate(),
    };

  emit('apply', appliedFilters);
};

const onClearClick = () => {
  selectedDates.value = { start: null, end: null };
  selectedProperty.value = null;
  selectedGuest.value = null;
  selectedStatus.value = null;

  applyFilters();
};

const onApplyClick = () => {
  applyFilters();
  isShown.value = false;
};
</script>